]> git.ipfire.org Git - thirdparty/git.git/blame - git-submodule.sh
sha1-file: split OBJECT_INFO_FOR_PREFETCH
[thirdparty/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
68cabbfd
DL
8USAGE="[--quiet] [--cached]
9 or: $dashless [--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 10 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 11 or: $dashless [--quiet] init [--] [<path>...]
f6a52799 12 or: $dashless [--quiet] deinit [-f|--force] (--all| [--] <path>...)
abed000a 13 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--[no-]recommend-shallow] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 14 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 15 or: $dashless [--quiet] foreach [--recursive] <command>
c32eaa8a
SB
16 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]
17 or: $dashless [--quiet] absorbgitdirs [--] [<path>...]"
8f321a39 18OPTIONS_SPEC=
091a6eb0 19SUBDIRECTORY_OK=Yes
70c7ac22 20. git-sh-setup
98fcf840 21. git-parse-remote
70c7ac22 22require_work_tree
091a6eb0
JK
23wt_prefix=$(git rev-parse --show-prefix)
24cd_to_toplevel
70c7ac22 25
f1762d77
BW
26# Tell the rest of git that any URLs we get don't come
27# directly from the user, so it can apply policy as appropriate.
28GIT_PROTOCOL_FROM_USER=0
29export GIT_PROTOCOL_FROM_USER
33cfccbb 30
5c08dbbd 31command=
ecda0723 32branch=
d27b876b 33force=
d92a3959 34reference=
70c7ac22 35cached=
48bb3033
GP
36recursive=
37init=
1c244f6e 38files=
06b1abb5 39remote=
31ca3ac3 40nofetch=
32948425 41update=
15fc56a8 42prefix=
73b0898d 43custom_name=
275cd184 44depth=
72c5f883 45progress=
a0ef2934 46dissociate=
70c7ac22 47
be9d0a3a
HV
48die_if_unmatched ()
49{
50 if test "$1" = "#unmatched"
51 then
c4c02bf1 52 exit ${2:-1}
be9d0a3a
HV
53 fi
54}
55
88ce00c3
TK
56#
57# Print a submodule configuration setting
58#
59# $1 = submodule name
60# $2 = option name
61# $3 = default value
62#
63# Checks in the usual git-config places first (for overrides),
64# otherwise it falls back on .gitmodules. This allows you to
65# distribute project-wide defaults in .gitmodules, while still
66# customizing individual repositories if necessary. If the option is
67# not in .gitmodules either, print a default value.
68#
69get_submodule_config () {
70 name="$1"
71 option="$2"
72 default="$3"
73 value=$(git config submodule."$name"."$option")
74 if test -z "$value"
75 then
b2faad44 76 value=$(git submodule--helper config submodule."$name"."$option")
88ce00c3
TK
77 fi
78 printf '%s' "${value:-$default}"
79}
80
862ae6cd
RS
81isnumber()
82{
83 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
84}
85
dda63468 86# Given a full hex object ID, is this the zero OID?
87is_zero_oid () {
88 echo "$1" | sane_egrep '^0+$' >/dev/null 2>&1
89}
90
14111fc4
JK
91# Sanitize the local git environment for use within a submodule. We
92# can't simply use clear_local_git_env since we want to preserve some
93# of the settings from GIT_CONFIG_PARAMETERS.
94sanitize_submodule_env()
95{
89044baa 96 save_config=$GIT_CONFIG_PARAMETERS
14111fc4 97 clear_local_git_env
89044baa 98 GIT_CONFIG_PARAMETERS=$save_config
860cba61 99 export GIT_CONFIG_PARAMETERS
14111fc4
JK
100}
101
ecda0723
SV
102#
103# Add a new submodule to the working tree, .gitmodules and the index
104#
ec05df35 105# $@ = repo path
ecda0723
SV
106#
107# optional branch is stored in global branch variable
108#
23a485e3 109cmd_add()
ecda0723 110{
5c08dbbd 111 # parse $args after "submodule ... add".
091a6eb0 112 reference_path=
5c08dbbd
JH
113 while test $# -ne 0
114 do
115 case "$1" in
116 -b | --branch)
117 case "$2" in '') usage ;; esac
118 branch=$2
119 shift
120 ;;
d27b876b
JL
121 -f | --force)
122 force=$1
123 ;;
5c08dbbd 124 -q|--quiet)
2e6a30ef 125 GIT_QUIET=1
5c08dbbd 126 ;;
6d33e1c2
CF
127 --progress)
128 progress=1
129 ;;
d92a3959
MT
130 --reference)
131 case "$2" in '') usage ;; esac
091a6eb0 132 reference_path=$2
d92a3959
MT
133 shift
134 ;;
135 --reference=*)
091a6eb0 136 reference_path="${1#--reference=}"
d92a3959 137 ;;
a0ef2934
CF
138 --dissociate)
139 dissociate=1
140 ;;
73b0898d
JL
141 --name)
142 case "$2" in '') usage ;; esac
143 custom_name=$2
144 shift
145 ;;
275cd184
FG
146 --depth)
147 case "$2" in '') usage ;; esac
148 depth="--depth=$2"
149 shift
150 ;;
151 --depth=*)
152 depth=$1
153 ;;
5c08dbbd
JH
154 --)
155 shift
156 break
157 ;;
158 -*)
159 usage
160 ;;
161 *)
162 break
163 ;;
164 esac
165 shift
166 done
167
76e9bdc4
AO
168 if ! git submodule--helper config --check-writeable >/dev/null 2>&1
169 then
170 die "$(eval_gettext "please make sure that the .gitmodules file is in the working tree")"
171 fi
172
091a6eb0
JK
173 if test -n "$reference_path"
174 then
175 is_absolute_path "$reference_path" ||
176 reference_path="$wt_prefix$reference_path"
177
178 reference="--reference=$reference_path"
179 fi
180
ecda0723 181 repo=$1
64394e3a 182 sm_path=$2
ecda0723 183
64394e3a 184 if test -z "$sm_path"; then
6a066230 185 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
186 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
187 fi
188
496eeeb1 189 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
190 usage
191 fi
192
091a6eb0
JK
193 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
194
ec05df35
ML
195 # assure repo is absolute or relative to parent
196 case "$repo" in
197 ./*|../*)
091a6eb0
JK
198 test -z "$wt_prefix" ||
199 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
200
ec05df35 201 # dereference source url relative to parent's url
63e95beb 202 realrepo=$(git submodule--helper resolve-relative-url "$repo") || exit
ec05df35
ML
203 ;;
204 *:*|/*)
205 # absolute url
206 realrepo=$repo
207 ;;
208 *)
497ee872 209 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
210 ;;
211 esac
212
db75ada5
MG
213 # normalize path:
214 # multiple //; leading ./; /./; /../; trailing /
64394e3a 215 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
216 sed -e '
217 s|//*|/|g
218 s|^\(\./\)*||
8196e728 219 s|/\(\./\)*|/|g
db75ada5
MG
220 :start
221 s|\([^/]*\)/\.\./||
222 tstart
223 s|/*$||
224 ')
619acfc7
SB
225 if test -z "$force"
226 then
227 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
228 die "$(eval_gettext "'\$sm_path' already exists in the index")"
229 else
230 git ls-files -s "$sm_path" | sane_grep -v "^160000" > /dev/null 2>&1 &&
231 die "$(eval_gettext "'\$sm_path' already exists in the index and is not a submodule")"
232 fi
ecda0723 233
53213994
JK
234 if test -z "$force" &&
235 ! git add --dry-run --ignore-missing --no-warn-embedded-repo "$sm_path" > /dev/null 2>&1
d27b876b 236 then
6ff875c5 237 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 238\$sm_path
6ff875c5 239Use -f if you really want to add it." >&2
d27b876b
JL
240 exit 1
241 fi
242
73b0898d
JL
243 if test -n "$custom_name"
244 then
245 sm_name="$custom_name"
246 else
247 sm_name="$sm_path"
248 fi
249
0383bbb9
JK
250 if ! git submodule--helper check-name "$sm_name"
251 then
252 die "$(eval_gettext "'$sm_name' is not a valid submodule name")"
253 fi
254
d4264ca3 255 # perhaps the path exists and is already a git repo, else clone it
64394e3a 256 if test -e "$sm_path"
d4264ca3 257 then
496eeeb1 258 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 259 then
64394e3a 260 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 261 else
64394e3a 262 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 263 fi
c2f93917 264
d4264ca3 265 else
4b7c286e
JL
266 if test -d ".git/modules/$sm_name"
267 then
268 if test -z "$force"
269 then
0d71dbfd 270 eval_gettextln >&2 "A git directory for '\$sm_name' is found locally with remote(s):"
4b7c286e 271 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
0d71dbfd
VA
272 die "$(eval_gettextln "\
273If you want to reuse this local git directory instead of cloning again from
274 \$realrepo
275use the '--force' option. If the local git directory is not the correct repo
276or you are unsure what this means choose another name with the '--name' option.")"
4b7c286e 277 else
0d71dbfd 278 eval_gettextln "Reactivating local git directory for submodule '\$sm_name'."
4b7c286e
JL
279 fi
280 fi
a0ef2934 281 git submodule--helper clone ${GIT_QUIET:+--quiet} ${progress:+"--progress"} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${dissociate:+"--dissociate"} ${depth:+"$depth"} || exit
d851ffb9 282 (
14111fc4 283 sanitize_submodule_env
d851ffb9
JH
284 cd "$sm_path" &&
285 # ash fails to wordsplit ${branch:+-b "$branch"...}
286 case "$branch" in
287 '') git checkout -f -q ;;
288 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
289 esac
290 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 291 fi
73b0898d 292 git config submodule."$sm_name".url "$realrepo"
d4264ca3 293
53213994 294 git add --no-warn-embedded-repo $force "$sm_path" ||
64394e3a 295 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 296
b2faad44
AO
297 git submodule--helper config submodule."$sm_name".path "$sm_path" &&
298 git submodule--helper config submodule."$sm_name".url "$repo" &&
b9289227
TK
299 if test -n "$branch"
300 then
b2faad44 301 git submodule--helper config submodule."$sm_name".branch "$branch"
b9289227 302 fi &&
31991b02 303 git add --force .gitmodules ||
64394e3a 304 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
1b614c07
BW
305
306 # NEEDSWORK: In a multi-working-tree world, this needs to be
307 # set in the per-worktree config.
308 if git config --get submodule.active >/dev/null
309 then
310 # If the submodule being adding isn't already covered by the
311 # current configured pathspec, set the submodule's active flag
312 if ! git submodule--helper is-active "$sm_path"
313 then
314 git config submodule."$sm_name".active "true"
315 fi
316 else
317 git config submodule."$sm_name".active "true"
318 fi
ecda0723
SV
319}
320
19a31f9c
ML
321#
322# Execute an arbitrary command sequence in each checked out
323# submodule
324#
325# $@ = command to execute
326#
327cmd_foreach()
328{
1d5bec8b
JH
329 # parse $args after "submodule ... foreach".
330 while test $# -ne 0
331 do
332 case "$1" in
333 -q|--quiet)
334 GIT_QUIET=1
335 ;;
15fc56a8
JH
336 --recursive)
337 recursive=1
338 ;;
1d5bec8b
JH
339 -*)
340 usage
341 ;;
342 *)
343 break
344 ;;
345 esac
346 shift
347 done
348
fc1b9243 349 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper foreach ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
19a31f9c
ML
350}
351
70c7ac22 352#
211b7f19 353# Register submodules in .git/config
70c7ac22
LH
354#
355# $@ = requested paths (default to all)
356#
23a485e3 357cmd_init()
70c7ac22 358{
5c08dbbd
JH
359 # parse $args after "submodule ... init".
360 while test $# -ne 0
361 do
362 case "$1" in
363 -q|--quiet)
2e6a30ef 364 GIT_QUIET=1
5c08dbbd
JH
365 ;;
366 --)
367 shift
368 break
369 ;;
370 -*)
371 usage
372 ;;
373 *)
374 break
375 ;;
376 esac
377 shift
378 done
379
6e7c14e6 380 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper init ${GIT_QUIET:+--quiet} "$@"
70c7ac22
LH
381}
382
cf419828
JL
383#
384# Unregister submodules from .git/config and remove their work tree
385#
cf419828
JL
386cmd_deinit()
387{
388 # parse $args after "submodule ... deinit".
f6a52799 389 deinit_all=
cf419828
JL
390 while test $# -ne 0
391 do
392 case "$1" in
393 -f|--force)
394 force=$1
395 ;;
396 -q|--quiet)
397 GIT_QUIET=1
398 ;;
f6a52799
SB
399 --all)
400 deinit_all=t
401 ;;
cf419828
JL
402 --)
403 shift
404 break
405 ;;
406 -*)
407 usage
408 ;;
409 *)
410 break
411 ;;
412 esac
413 shift
414 done
415
2e612731 416 git ${wt_prefix:+-C "$wt_prefix"} submodule--helper deinit ${GIT_QUIET:+--quiet} ${prefix:+--prefix "$prefix"} ${force:+--force} ${deinit_all:+--all} "$@"
cf419828
JL
417}
418
fb43e31f 419is_tip_reachable () (
01e1d544 420 sanitize_submodule_env &&
fb43e31f
SB
421 cd "$1" &&
422 rev=$(git rev-list -n 1 "$2" --not --all 2>/dev/null) &&
423 test -z "$rev"
424)
425
426fetch_in_submodule () (
01e1d544 427 sanitize_submodule_env &&
fb43e31f
SB
428 cd "$1" &&
429 case "$2" in
430 '')
431 git fetch ;;
432 *)
6cbf454a
SB
433 shift
434 git fetch $(get_default_remote) "$@" ;;
fb43e31f
SB
435 esac
436)
437
70c7ac22 438#
211b7f19 439# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
440#
441# $@ = requested paths (default to all)
442#
23a485e3 443cmd_update()
70c7ac22 444{
5c08dbbd
JH
445 # parse $args after "submodule ... update".
446 while test $# -ne 0
447 do
448 case "$1" in
449 -q|--quiet)
2e6a30ef 450 GIT_QUIET=1
5c08dbbd 451 ;;
e84c3cf3
SB
452 -v)
453 GIT_QUIET=0
454 ;;
72c5f883 455 --progress)
c7199e3a 456 progress=1
72c5f883 457 ;;
be4d2c83 458 -i|--init)
d92a3959 459 init=1
be4d2c83 460 ;;
06b1abb5
TK
461 --remote)
462 remote=1
463 ;;
31ca3ac3 464 -N|--no-fetch)
31ca3ac3
FF
465 nofetch=1
466 ;;
9db31bdf
NMC
467 -f|--force)
468 force=$1
469 ;;
ca2cedba 470 -r|--rebase)
32948425 471 update="rebase"
ca2cedba 472 ;;
d92a3959
MT
473 --reference)
474 case "$2" in '') usage ;; esac
475 reference="--reference=$2"
98dbe63d 476 shift
d92a3959
MT
477 ;;
478 --reference=*)
479 reference="$1"
d92a3959 480 ;;
a0ef2934
CF
481 --dissociate)
482 dissociate=1
483 ;;
42b49178 484 -m|--merge)
42b49178
JH
485 update="merge"
486 ;;
b13fd5c1 487 --recursive)
b13fd5c1
JH
488 recursive=1
489 ;;
efc5fb6a
JH
490 --checkout)
491 update="checkout"
492 ;;
abed000a
SB
493 --recommend-shallow)
494 recommend_shallow="--recommend-shallow"
495 ;;
496 --no-recommend-shallow)
497 recommend_shallow="--no-recommend-shallow"
498 ;;
275cd184
FG
499 --depth)
500 case "$2" in '') usage ;; esac
501 depth="--depth=$2"
502 shift
503 ;;
504 --depth=*)
505 depth=$1
506 ;;
2335b870
SB
507 -j|--jobs)
508 case "$2" in '') usage ;; esac
509 jobs="--jobs=$2"
510 shift
511 ;;
512 --jobs=*)
513 jobs=$1
514 ;;
5c08dbbd
JH
515 --)
516 shift
517 break
518 ;;
519 -*)
520 usage
521 ;;
522 *)
523 break
524 ;;
525 esac
98dbe63d 526 shift
5c08dbbd
JH
527 done
528
d92a3959
MT
529 if test -n "$init"
530 then
531 cmd_init "--" "$@" || return
532 fi
533
48308681
SB
534 {
535 git submodule--helper update-clone ${GIT_QUIET:+--quiet} \
c7199e3a 536 ${progress:+"--progress"} \
48308681
SB
537 ${wt_prefix:+--prefix "$wt_prefix"} \
538 ${prefix:+--recursive-prefix "$prefix"} \
539 ${update:+--update "$update"} \
5f50f33e 540 ${reference:+"$reference"} \
a0ef2934 541 ${dissociate:+"--dissociate"} \
48308681 542 ${depth:+--depth "$depth"} \
c7199e3a
CF
543 $recommend_shallow \
544 $jobs \
c4c02bf1 545 "$@" || echo "#unmatched" $?
48308681 546 } | {
15ffb7cd 547 err=
9eca701f 548 while read -r quickabort sha1 just_cloned sm_path
70c7ac22 549 do
9eca701f 550 die_if_unmatched "$quickabort" "$sha1"
48308681 551
5d124f41 552 git submodule--helper ensure-core-worktree "$sm_path" || exit 1
74d4731d 553
ee69b2a9 554 update_module=$(git submodule--helper update-module-mode $just_cloned "$sm_path" $update)
efc5fb6a 555
44431df0 556 displaypath=$(git submodule--helper relative-path "$prefix$sm_path" "$wt_prefix")
091a6eb0 557
48308681 558 if test $just_cloned -eq 1
d851ffb9 559 then
bf2d8246
LH
560 subsha1=
561 else
14111fc4 562 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 563 git rev-parse --verify HEAD) ||
091a6eb0 564 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 565 fi
211b7f19 566
06b1abb5
TK
567 if test -n "$remote"
568 then
92bbe7cc 569 branch=$(git submodule--helper remote-branch "$sm_path")
06b1abb5
TK
570 if test -z "$nofetch"
571 then
572 # Fetch remote before determining tracking $sha1
6cbf454a 573 fetch_in_submodule "$sm_path" $depth ||
06b1abb5
TK
574 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
575 fi
14111fc4
JK
576 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
577 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5 578 git rev-parse --verify "${remote_name}/${branch}") ||
c87302bf 579 die "$(eval_gettext "Unable to find current \${remote_name}/\${branch} revision in submodule path '\$sm_path'")"
06b1abb5
TK
580 fi
581
496eeeb1 582 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 583 then
9db31bdf
NMC
584 subforce=$force
585 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 586 if test -z "$subsha1" && test -z "$force"
b9b378a0 587 then
9db31bdf 588 subforce="-f"
b9b378a0 589 fi
31ca3ac3
FF
590
591 if test -z "$nofetch"
592 then
e5f522d6
JL
593 # Run fetch only if $sha1 isn't present or it
594 # is not reachable from a ref.
fb43e31f 595 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 596 fetch_in_submodule "$sm_path" $depth ||
e30d8336 597 say "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
fb43e31f
SB
598
599 # Now we tried the usual fetch, but $sha1 may
600 # not be reachable from any of the refs
601 is_tip_reachable "$sm_path" "$sha1" ||
6cbf454a 602 fetch_in_submodule "$sm_path" $depth "$sha1" ||
c87302bf 603 die "$(eval_gettext "Fetched in submodule path '\$displaypath', but it did not contain \$sha1. Direct fetching of that commit failed.")"
31ca3ac3
FF
604 fi
605
877449c1 606 must_die_on_failure=
32948425 607 case "$update_module" in
a2aed08b
TK
608 checkout)
609 command="git checkout $subforce -q"
610 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
611 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
612 ;;
32948425
JH
613 rebase)
614 command="git rebase"
091a6eb0
JK
615 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
616 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 617 must_die_on_failure=yes
32948425 618 ;;
42b49178
JH
619 merge)
620 command="git merge"
091a6eb0
JK
621 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
622 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 623 must_die_on_failure=yes
42b49178 624 ;;
6cb5728c
CP
625 !*)
626 command="${update_module#!}"
b08238ac
SB
627 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$displaypath'")"
628 say_msg="$(eval_gettext "Submodule path '\$displaypath': '\$command \$sha1'")"
6cb5728c
CP
629 must_die_on_failure=yes
630 ;;
32948425 631 *)
ff03d930 632 die "$(eval_gettext "Invalid update mode '$update_module' for submodule path '$path'")"
32948425 633 esac
70c7ac22 634
14111fc4 635 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 636 then
ff968f03 637 say "$say_msg"
877449c1
JH
638 elif test -n "$must_die_on_failure"
639 then
ff968f03 640 die_with_status 2 "$die_msg"
15ffb7cd 641 else
ff968f03 642 err="${err};$die_msg"
877449c1 643 continue
15ffb7cd 644 fi
70c7ac22 645 fi
b13fd5c1
JH
646
647 if test -n "$recursive"
648 then
75bf5e60 649 (
44431df0 650 prefix=$(git submodule--helper relative-path "$prefix$sm_path/" "$wt_prefix")
3604242f 651 wt_prefix=
14111fc4 652 sanitize_submodule_env
75bf5e60 653 cd "$sm_path" &&
36141282 654 eval cmd_update
75bf5e60 655 )
15ffb7cd
FG
656 res=$?
657 if test $res -gt 0
658 then
091a6eb0 659 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
bb9d91b4 660 if test $res -ne 2
15ffb7cd 661 then
ff968f03 662 err="${err};$die_msg"
15ffb7cd
FG
663 continue
664 else
ff968f03 665 die_with_status $res "$die_msg"
15ffb7cd
FG
666 fi
667 fi
b13fd5c1 668 fi
70c7ac22 669 done
15ffb7cd
FG
670
671 if test -n "$err"
672 then
673 OIFS=$IFS
674 IFS=';'
675 for e in $err
676 do
677 if test -n "$e"
678 then
679 echo >&2 "$e"
680 fi
681 done
682 IFS=$OIFS
683 exit 1
684 fi
685 }
70c7ac22
LH
686}
687
28f9af5d
PY
688#
689# Show commit summary for submodules in index or working tree
690#
691# If '--cached' is given, show summary between index and given commit,
692# or between working tree and given commit
693#
694# $@ = [commit (default 'HEAD'),] requested paths (default all)
695#
696cmd_summary() {
f2dc06a3 697 summary_limit=-1
d0f64dd4 698 for_status=
1c244f6e 699 diff_cmd=diff-index
f2dc06a3 700
28f9af5d
PY
701 # parse $args after "submodule ... summary".
702 while test $# -ne 0
703 do
704 case "$1" in
705 --cached)
706 cached="$1"
707 ;;
1c244f6e
JL
708 --files)
709 files="$1"
710 ;;
d0f64dd4
PY
711 --for-status)
712 for_status="$1"
713 ;;
f2dc06a3 714 -n|--summary-limit)
862ae6cd
RS
715 summary_limit="$2"
716 isnumber "$summary_limit" || usage
f2dc06a3
PY
717 shift
718 ;;
862ae6cd
RS
719 --summary-limit=*)
720 summary_limit="${1#--summary-limit=}"
721 isnumber "$summary_limit" || usage
722 ;;
28f9af5d
PY
723 --)
724 shift
725 break
726 ;;
727 -*)
728 usage
729 ;;
730 *)
731 break
732 ;;
733 esac
734 shift
735 done
bffe71f4 736
f2dc06a3
PY
737 test $summary_limit = 0 && return
738
3deea89c 739 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
740 then
741 head=$rev
caa9c3ca 742 test $# = 0 || shift
496eeeb1 743 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 744 then
14e940d7
JH
745 # before the first commit: compare with an empty tree
746 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 747 test -z "$1" || shift
28f9af5d 748 else
3deea89c 749 head="HEAD"
28f9af5d
PY
750 fi
751
1c244f6e
JL
752 if [ -n "$files" ]
753 then
754 test -n "$cached" &&
465d6a00 755 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
756 diff_cmd=diff-files
757 head=
758 fi
759
28f9af5d 760 cd_to_toplevel
091a6eb0 761 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 762 # Get modified modules cared by user
18076502 763 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 764 sane_egrep '^:([0-7]* )?160000' |
cf9e55f4 765 while read -r mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
766 do
767 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
768 if test "$status" = D || test "$status" = T
769 then
6a066230 770 printf '%s\n' "$sm_path"
496eeeb1
EP
771 continue
772 fi
927b26f8 773 # Respect the ignore setting for --for-status.
774 if test -n "$for_status"
775 then
0ea306ef 776 name=$(git submodule--helper name "$sm_path")
927b26f8 777 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 778 test $status != A && test $ignore_config = all && continue
927b26f8 779 fi
28f9af5d 780 # Also show added or modified modules which are checked out
974ce807 781 GIT_DIR="$sm_path/.git" git rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 782 printf '%s\n' "$sm_path"
28f9af5d
PY
783 done
784 )
1cb639e6 785
d0f64dd4
PY
786 test -z "$modules" && return
787
18076502 788 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 789 sane_egrep '^:([0-7]* )?160000' |
1cb639e6 790 cut -c2- |
cf9e55f4 791 while read -r mod_src mod_dst sha1_src sha1_dst status name
1cb639e6
PY
792 do
793 if test -z "$cached" &&
dda63468 794 is_zero_oid $sha1_dst
1cb639e6
PY
795 then
796 case "$mod_dst" in
797 160000)
798 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
799 ;;
800 100644 | 100755 | 120000)
801 sha1_dst=$(git hash-object $name)
802 ;;
803 000000)
804 ;; # removed
805 *)
806 # unexpected type
6ff875c5 807 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
808 continue ;;
809 esac
810 fi
811 missing_src=
812 missing_dst=
813
814 test $mod_src = 160000 &&
974ce807 815 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
816 missing_src=t
817
818 test $mod_dst = 160000 &&
974ce807 819 ! GIT_DIR="$name/.git" git rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 820 missing_dst=t
bffe71f4 821
44431df0 822 display_name=$(git submodule--helper relative-path "$name" "$wt_prefix")
091a6eb0 823
1cb639e6
PY
824 total_commits=
825 case "$missing_src,$missing_dst" in
826 t,)
091a6eb0 827 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
828 ;;
829 ,t)
091a6eb0 830 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
831 ;;
832 t,t)
091a6eb0 833 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
834 ;;
835 *)
836 errmsg=
837 total_commits=$(
496eeeb1 838 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
839 then
840 range="$sha1_src...$sha1_dst"
841 elif test $mod_src = 160000
842 then
843 range=$sha1_src
844 else
845 range=$sha1_dst
846 fi
847 GIT_DIR="$name/.git" \
b0e621ad 848 git rev-list --first-parent $range -- | wc -l
1cb639e6 849 )
eed35595 850 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
851 ;;
852 esac
853
0586a438
SH
854 sha1_abbr_src=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_src 2>/dev/null ||
855 echo $sha1_src | cut -c1-7)
856 sha1_abbr_dst=$(GIT_DIR="$name/.git" git rev-parse --short $sha1_dst 2>/dev/null ||
857 echo $sha1_dst | cut -c1-7)
858
1cb639e6
PY
859 if test $status = T
860 then
b3e73449
ÆAB
861 blob="$(gettext "blob")"
862 submodule="$(gettext "submodule")"
1cb639e6
PY
863 if test $mod_dst = 160000
864 then
091a6eb0 865 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 866 else
091a6eb0 867 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
868 fi
869 else
091a6eb0 870 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
871 fi
872 if test -n "$errmsg"
873 then
874 # Don't give error msg for modification whose dst is not submodule
875 # i.e. deleted or changed to blob
876 test $mod_dst = 160000 && echo "$errmsg"
877 else
496eeeb1 878 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 879 then
f2dc06a3
PY
880 limit=
881 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 882 GIT_DIR="$name/.git" \
f2dc06a3 883 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
884 --first-parent $sha1_src...$sha1_dst
885 elif test $mod_dst = 160000
886 then
887 GIT_DIR="$name/.git" \
888 git log --pretty='format: > %s' -1 $sha1_dst
889 else
890 GIT_DIR="$name/.git" \
891 git log --pretty='format: < %s' -1 $sha1_src
892 fi
893 echo
894 fi
895 echo
3ba7407b 896 done
28f9af5d 897}
70c7ac22 898#
941987a5 899# List all submodules, prefixed with:
70c7ac22
LH
900# - submodule not initialized
901# + different revision checked out
902#
903# If --cached was specified the revision in the index will be printed
904# instead of the currently checked out revision.
905#
906# $@ = requested paths (default to all)
907#
23a485e3 908cmd_status()
70c7ac22 909{
5c08dbbd
JH
910 # parse $args after "submodule ... status".
911 while test $# -ne 0
912 do
913 case "$1" in
914 -q|--quiet)
2e6a30ef 915 GIT_QUIET=1
5c08dbbd
JH
916 ;;
917 --cached)
918 cached=1
919 ;;
64b19ffe
JH
920 --recursive)
921 recursive=1
922 ;;
5c08dbbd
JH
923 --)
924 shift
925 break
926 ;;
927 -*)
928 usage
929 ;;
930 *)
931 break
932 ;;
933 esac
934 shift
935 done
936
a9f8a375 937 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper status ${GIT_QUIET:+--quiet} ${cached:+--cached} ${recursive:+--recursive} "$@"
70c7ac22 938}
2327f61e
DA
939#
940# Sync remote urls for submodules
941# This makes the value for remote.$remote.url match the value
942# specified in .gitmodules.
943#
944cmd_sync()
945{
946 while test $# -ne 0
947 do
948 case "$1" in
949 -q|--quiet)
2e6a30ef 950 GIT_QUIET=1
2327f61e
DA
951 shift
952 ;;
82f49f29
PH
953 --recursive)
954 recursive=1
955 shift
956 ;;
2327f61e
DA
957 --)
958 shift
959 break
960 ;;
961 -*)
962 usage
963 ;;
964 *)
965 break
966 ;;
967 esac
968 done
e7849a96 969
13424764 970 git ${wt_prefix:+-C "$wt_prefix"} ${prefix:+--super-prefix "$prefix"} submodule--helper sync ${GIT_QUIET:+--quiet} ${recursive:+--recursive} "$@"
2327f61e 971}
70c7ac22 972
f6f85861
SB
973cmd_absorbgitdirs()
974{
975 git submodule--helper absorb-git-dirs --prefix "$wt_prefix" "$@"
976}
977
5c08dbbd
JH
978# This loop parses the command line arguments to find the
979# subcommand name to dispatch. Parsing of the subcommand specific
980# options are primarily done by the subcommand implementations.
981# Subcommand specific options such as --branch and --cached are
982# parsed here as well, for backward compatibility.
983
984while test $# != 0 && test -z "$command"
70c7ac22
LH
985do
986 case "$1" in
f6f85861 987 add | foreach | init | deinit | update | status | summary | sync | absorbgitdirs)
5c08dbbd 988 command=$1
70c7ac22
LH
989 ;;
990 -q|--quiet)
2e6a30ef 991 GIT_QUIET=1
70c7ac22 992 ;;
ecda0723
SV
993 -b|--branch)
994 case "$2" in
995 '')
996 usage
997 ;;
998 esac
999 branch="$2"; shift
1000 ;;
70c7ac22 1001 --cached)
28f9af5d 1002 cached="$1"
70c7ac22
LH
1003 ;;
1004 --)
1005 break
1006 ;;
1007 -*)
1008 usage
1009 ;;
1010 *)
1011 break
1012 ;;
1013 esac
1014 shift
1015done
1016
5c08dbbd 1017# No command word defaults to "status"
af9c9f97
RR
1018if test -z "$command"
1019then
1020 if test $# = 0
1021 then
1022 command=status
1023 else
1024 usage
1025 fi
1026fi
5c08dbbd
JH
1027
1028# "-b branch" is accepted only by "add"
1029if test -n "$branch" && test "$command" != add
1030then
ecda0723 1031 usage
5c08dbbd
JH
1032fi
1033
28f9af5d 1034# "--cached" is accepted only by "status" and "summary"
496eeeb1 1035if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1036then
70c7ac22 1037 usage
5c08dbbd
JH
1038fi
1039
1040"cmd_$command" "$@"